/// <reference types="node" />
import type { Provider } from '@nestjs/common';
import { AsyncLocalStorage } from 'async_hooks';
import { AsyncLocalStorageModuleOptions, ContextStoreProperties } from './async-local-storage.interfaces';
import { AsyncLocalStorageService } from './async-local-storage.service';
declare type K = keyof ContextStoreProperties;
declare type T = ContextStoreProperties;
declare type StoreMap = Map<K, T[K]>;
export declare function createAsyncLocalStorageProviders(options: AsyncLocalStorageModuleOptions): [
    Provider<AsyncLocalStorage<StoreMap>>,
    Provider<AsyncLocalStorageModuleOptions>,
    Provider<AsyncLocalStorageService>
];
export {};
