import { CanActivate, ExecutionContext } from '@nestjs/common';
import { AsyncLocalStorageModuleOptions } from './async-local-storage.interfaces';
import { AsyncLocalStorageService } from './async-local-storage.service';
export declare class AsyncLocalStorageGuard implements CanActivate {
    private readonly asyncLocalStorage;
    private readonly options;
    constructor(asyncLocalStorage: AsyncLocalStorageService, options: AsyncLocalStorageModuleOptions);
    canActivate(context: ExecutionContext): boolean;
}
