import { CallHandler, ExecutionContext, NestInterceptor } from '@nestjs/common';
import { Observable } from 'rxjs';
import { AsyncLocalStorageMode, AsyncLocalStorageModuleOptions } from './async-local-storage.interfaces';
import { AsyncLocalStorageService } from './async-local-storage.service';
export declare class AsyncLocalStorageInterceptor implements NestInterceptor {
    private readonly asyncLocalStorage;
    private readonly options;
    readonly mode: AsyncLocalStorageMode;
    constructor(asyncLocalStorage: AsyncLocalStorageService, options: AsyncLocalStorageModuleOptions);
    intercept(context: ExecutionContext, next: CallHandler): Promise<Observable<unknown>>;
}
